# -*- coding: utf-8 -*-

import cog
import xml.etree.ElementTree as et

def getopt(xmlconf):
	try:
		xml = et.parse(xmlconf)
	except:
		cog.error('XMLConf: can\'t open file: %s' % xmlconf)
	try:
		name = xml.find('/').attrib['name']
	except:
		cog.error('XMLConf:\n<project name="">')
	try:
		ver = xml.find('/').attrib['version']
	except:
		cog.error('XMLConf:\n<project version="">')
	try:
		build = xml.find('/').attrib['build']
	except:
		build = False
	try:
		mcu = xml.find('/mcu').attrib['value']
	except:
		cog.error('XMLConf: in\n<project>\n\t<mcu value=""/>')
	try:
		xtal = float(xml.find('/xtal').attrib['value'])
	except:
		cog.error('XMLConf: in\n<project>\n\t<xtal value=""/>')
	try:
		tosc = float(xml.find('/tosc').attrib['value'])
	except:
		tosc = False

	return ((name, ver, build), mcu, xtal, tosc)

def increment_build(xmlconf):
	'''if <project build=""> exist increment build and write'''
	try:
		xml = et.parse(xmlconf)
	except:
		cog.error('XMLConf: can\'t open file: %s' % xmlconf)
	try:
		build = xml.find('/')
		build.attrib['build'] = str(int(build.attrib['build'])+1)
		try:
			xml.write(xmlconf)
		except:
			cog.error('XMLConf: can\'t write to file: %s' % xmlconf)
	except:
		#cog.msg('XMLConf: <project build=""> not used.')
		pass

def out(xmlconf):
	increment_build(xmlconf)
	((name, ver, build), mcu, xtal, tosc) = getopt(xmlconf)

	cog.outl('#define PROJECT_NAME "%s"' % name)
	cog.outl('#define PROJECT_VERSION "%s"' % ver)
	if build:
		cog.outl('#define PROJECT_BUILD %s' % build)
	cog.outl('#define PROJECT_MCU "%s"' % mcu)
	cog.outl('#define PROJECT_XTAL %sUL' % int(xtal))
	if tosc:
		cog.outl('#define PROJECT_TOSC %sUL' % int(tosc))
	if build:
		cog.outl("\n#define PROJECT_ID \"%s %s-%s\"" % (name, ver, build))
	else:
		cog.outl("\n#define PROJECT_ID \"%s %s\"" % (name, ver))

