# -*- coding: utf-8 -*-

import cog
import xml.etree.ElementTree as et

def getopt(xmlconf):
	xml = et.parse(xmlconf)
	try:
		lang = xml.find('/make/dox/language').attrib['value']
	except:
		lang = "English"
	try:
		name = xml.find('/').attrib['name']
	except:
		cog.error('XMLConf: <project name=""> not specified!')
	try:
		ver = xml.find('/').attrib['version']
	except:
		cog.error('XMLConf: <project version=""> not specified!')
	try:
		build = xml.find('/').attrib['build']
	except:
		build = False

	return (name, lang, ver, build)

def out(xmlconf):
	(name, lang, ver, build) = getopt(xmlconf)

	cog.outl('PROJECT_NAME\t=\t"%s"' % name)
	if build:
		cog.outl('PROJECT_NUMBER\t=\t"%s build %s"' % (ver, build))
	else:
		cog.outl('PROJECT_NUMBER\t=\t"%s"' % ver)
	cog.outl('OUTPUT_LANGUAGE\t=\t%s' % lang)