# -*- coding: utf-8 -*-

import cog
import xml.etree.ElementTree as et

def getopt(xmlconf):
	try:
		xml = et.parse(xmlconf)
	except:
		cog.error('XMLConf: can\'t open file: %s' % xmlconf)
	# compiller -----------------------------------------------------------
	try:
		mcu = xml.find('/mcu').attrib['value']
	except:
		cog.error('XMLConf: in\n<project>\n\t<mcu value=""/>')
	try:
		xtal = float(xml.find('/xtal').attrib['value'])
	except:
		cog.error('XMLConf: in\n<project>\n\t<xtal value=""/>')
	try:
		trg = xml.find('/make/target').attrib['value']
	except:
		cog.error('XMLConf: in\n<project>\n\t<make>\n\t\t<target value=""/>')
		#trg = 'a'
	try:
		cc = xml.find('/make/cc').attrib['value']
	except:
		cc = "avr-gcc"
	try:
		objcpy = xml.find('/make/objcpy').attrib['value']
	except:
		objcpy = "avr-objcopy"
	try:
		dirs = xml.find('/make/dirs').attrib['value']
	except:
		dirs = "."
	try:
		cflags = xml.find('/make/cflags').attrib['value']
	except:
		cflags = "-mmcu=$(mcu)"
	try:
		lflags = xml.find('/make/lflags').attrib['value']
	except:
		lflags = "-mmcu=$(mcu)"
	try:
		cclog = xml.find('/make/log').attrib['value']
	except:
		cclog = "cc.log"
	# doxygen -------------------------------------------------------------
	try:
		doxylog = xml.find('/make/dox/log').attrib['value']
	except:
		doxylog = "dox.log"

	return (mcu, xtal, trg, dirs,(cc, objcpy), (cflags, lflags), (cclog, doxylog), )


def out(xmlconf):
	(mcu, xtal, trg, dirs,(cc, objcpy), (cflags, lflags), (cclog, doxylog), ) = getopt(xmlconf)

	cog.outl('target := %s' % trg)
	cog.outl('f_cpu := %sUL' % int(xtal))
	cog.outl('mcu := %s' % mcu)
	cog.outl('src_dirs := %s' % dirs)
	# compiller -----------------------------------------------------------
	cog.outl('cc := %s' % cc)
	cog.outl('objcpy := %s' % objcpy)
	# flags ---------------------------------------------------------------
	cog.outl('cflags := %s -DF_CPU=$(f_cpu) -mmcu=$(mcu)' % cflags)
	cog.outl('lflags := %s -mmcu=$(mcu)' % lflags)
	# logs ----------------------------------------------------------------
	cog.outl('cclog := %s' % cclog)
	cog.outl('doxylog := %s' % doxylog)
	# programmer ----------------------------------------------------------
	cog.outl('programmer := %s' % programmer(xmlconf))
	# cog -----------------------------------------------------------------
	cog.outl('xmlconf := %s' % xmlconf)

def programmer(xmlconf):
	try:
		xml = et.parse(xmlconf)
	except:
		cog.error('XMLConf: can\'t open file: %s' % xmlconf)
	# programmer ----------------------------------------------------------
	try:
		prog = xml.find('/make/programmer/prog').attrib['value']
	except:
		prog = "uisp"
	try:
		adapter = xml.find('/make/programmer/adapter').attrib['value']
	except:
		adapter = "abb"
	try:
		port = xml.find('/make/programmer/port').attrib['value']
	except:
		port = "/dev/parport0"

	if prog == 'uisp':
		return "uisp -dprog=%s -dlpt=%s --erase --upload --verify if=./$(addsuffix .hex,$(target))" % (adapter, port)
	else:
		cog.error('XMLConf: %s programmer unsupported' % prog)
	